searchData={"items":[{"type":"behaviour","title":"Sqids","doc":"Sqids API\n\n> ℹ️ Check out the [docs entry page](readme.html) on how to make\n> `Sqids` easier to use by not passing the context on every encode/decode\n> call, through either:\n> * creation of context at compile time under a module attribute,\n> * or the `use Sqids` macro to generate functions that retrieve context transparently.","ref":"Sqids.html"},{"type":"callback","title":"Sqids.child_spec/0","doc":"Returns Supervisor child spec for callback module.","ref":"Sqids.html#c:child_spec/0"},{"type":"function","title":"Sqids.decode!/2","doc":"Decodes an `id` into zero or more `numbers` according to `sqids`'s alphabet.\n\nLike in the [reference implementation](https://github.com/sqids/sqids-spec),\nthe presence of unknown characters within `id` will result in an empty list\nbeing returned.","ref":"Sqids.html#decode!/2"},{"type":"function","title":"Sqids.encode/2","doc":"Tries to encode zero or more `numbers` into as an `id`, according to\n`sqids`'s alphabet, blocklist, and minimum length. Returns an error\notherwise.","ref":"Sqids.html#encode/2"},{"type":"function","title":"Sqids.encode!/2","doc":"Encodes zero or more `numbers` into an `id`, according to `sqids`'s alphabet,\nblocklist, and minimum length. Raises in case of error.","ref":"Sqids.html#encode!/2"},{"type":"type","title":"Sqids.enumerable/1","doc":"Wrapper type for Elixir 1.13 or older","ref":"Sqids.html#t:enumerable/1"},{"type":"function","title":"Sqids.new/1","doc":"Creates a context used for both encoding and decoding.\n\nCan receive a list of zero or more `t:opts/0`:\n* `alphabet`: a case and order -sensitive string containing the chars of which generated IDs will be made of;\n* `min_length`: the minimum length of your generated IDs (padding added if needed);\n* `blocklist`: an enumerable collection of strings which shouldn't appear in generated IDs.\n\nReturns error if any of the `t:opts/0` is invalid.","ref":"Sqids.html#new/1"},{"type":"function","title":"Sqids.new!/1","doc":"Like `new/0` and `new/1` but raises in case of error.","ref":"Sqids.html#new!/1"},{"type":"type","title":"Sqids.opts/0","doc":"Opts for `new/1`","ref":"Sqids.html#t:opts/0"},{"type":"opaque","title":"Sqids.t/0","doc":"Context for Sqids","ref":"Sqids.html#t:t/0"},{"type":"module","title":"Sqids.Agent","doc":"Storage for `Sqids` shared state.\nLike stdlib's [Agent](https://hexdocs.pm/elixir/1.15/Agent.html) but using\nOTP's [`persistent_term`](https://www.erlang.org/doc/man/persistent_term).","ref":"Sqids.Agent.html"},{"type":"module","title":"Sqids.Hacks","doc":"Workarounds","ref":"Sqids.Hacks.html"},{"type":"function","title":"Sqids.Hacks.dialyzed_ctx/1","doc":"Function to work around Dialyzer warnings on violating\ntype opacity when Sqids context is placed in a module attribute, since it\nbecomes \"hardcoded\" from Dialyzer's point of view.","ref":"Sqids.Hacks.html#dialyzed_ctx/1"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.2.1] - 2025-02-06","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir 1.18 to CI\n- OTP 27.2 to CI\n- latest blocklist tweaks","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- compilation warning on Elixir 1.18\n\n## [0.2.0] - 2024-10-12","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir 1.17 to CI\n- OTP 27.1 to CI","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- [BREAKING] in supervised Sqids, if you had some non-default options declared\n  but only the module's name defined as the supervisor child (as was\n  recommended by docs), the options wouldn't work. Sqids now raises if this\n  situation is detected to nudge users towards fixing it in the way that's best\n  for each individual.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- documentation on supervised Sqids: intended options were not passed\n- compilation warnings on Elixir 1.17\n\n## [0.1.3] - 2024-02-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir 1.16 to CI\n- OTP 26.2 to CI","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- decoding exception when ExUnit wasn't imported by caller (thanks to\n  https://github.com/tshakah)\n- typos in README (thanks to https://github.com/hanifanazka)\n- Credo warnings about [predicate function\n  names](https://hexdocs.pm/credo/Credo.Check.Readability.PredicateFunctionNames.html)\n\n## [0.1.2] - 2023-11-04","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- workaround for Dialyzer warnings when placing context in module attribute\n- oldest `sqids` version in which each function, type and callback is available","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Dialyzer warnings for suggestion of `sqids` context under module attribute\n\n## [0.1.1] - 2023-10-29","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- `new!/0` and `new!/1` to ease storing context in module attributes","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- unwarranted risk of new future warnings breaking the builds of sqids\n  dependents\n\n## [0.1.0] - 2023-10-28","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir implementation of [Sqids](https://sqids.org/)","ref":"changelog.html#added"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2023-present Sqids maintainers.\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Migration guide","doc":"# Migration guide\n\nWhenever there's an interface breaking change (a change in the project's major version),\nrequired migration instructions will be detailed in this file.","ref":"migration.html"},{"type":"extras","title":"From [0.1.x] to [0.2.x] - Migration guide","doc":"","ref":"migration.html#from-0-1-x-to-0-2-x"},{"type":"extras","title":"Update - Migration guide","doc":"If you use supervised Sqids and its entry under the Supervisor is just the module's name, change it:\n```elixir\n# before\nchildren = [\n  MyApp.Sqids\n]\n\n# after\nchildren = [\n  MyApp.Sqids.child_spec()\n]\n\n```\n\nAnd then update your Sqids-using module to either clear custom options that never had any effect (safest)\nor keep them if you want them to start working (BREAKS COMPATIBILITY WITH EXISTING IDs).\n```elixir\ndefmodule MyApp.Sqids do\n    use Sqids\n\n    @impl true\n    def child_spec do\n        child_spec([\n            # * either clear custom options (safe)\n            # * or keep them so they start working (BREAKS COMPATIBILITY)\n        ])\n    end\n```","ref":"migration.html#update"},{"type":"extras","title":"Sqids","doc":"# [Sqids Elixir](https://sqids.org/elixir)\n\n[![Hex downloads](https://img.shields.io/hexpm/dt/sqids.svg)](https://hex.pm/packages/sqids)\n[![License](https://img.shields.io/hexpm/l/sqids.svg)](https://github.com/sqids/sqids-elixir/blob/main/LICENSE)\n[![Elixir Versions](https://img.shields.io/badge/Elixir-1.7%20to%201.18-blue)](https://elixir-lang.org/)\n[![Erlang Versions](https://img.shields.io/badge/Erlang%2FOTP-21.3%20to%2027-blue)](https://www.erlang.org)\n[![CI status](https://github.com/sqids/sqids-elixir/actions/workflows/ci.yml/badge.svg)](https://github.com/sqids/sqids-elixir/actions/workflows/ci.yml)\n\n[Sqids](https://sqids.org/elixir) (*pronounced \"squids\"*) for Elixir is a\nlibrary for generating YouTube-looking IDs from numbers. These IDs are short,\ncan be generated with a custom alphabet and are collision-free. [Read\nmore](https://sqids.org/faq).\n\nThis is what they look like in URLs:\n```\nhttps://example.com/LchsyE\nhttps://example.com/Uxmq8Y\nhttps://example.com/3CwlG7\n```","ref":"readme.html"},{"type":"extras","title":"Why use them? - Sqids","doc":"The main purpose is visual: you can use Sqids if you'd like to expose integer\nidentifiers in your software as alphanumeric strings.","ref":"readme.html#why-use-them"},{"type":"extras","title":"✅ Use Cases - Sqids","doc":"* **Link shortening**: default alphabet is safe to use in URLs, and common\n  profanity is avoided\n* **Event IDs**: collision-free ID generation\n* **Database lookups**: by decoding IDs back into numbers","ref":"readme.html#use-cases"},{"type":"extras","title":"❌ Not Good For - Sqids","doc":"* **Sensitive data**: this it not an encryption library\n* **User IDs** generated in sequence, or equivalents, which can be decoded,\n  revealing user count and/or business growth","ref":"readme.html#not-good-for"},{"type":"extras","title":"Features - Sqids","doc":"* 🆔 Generate short IDs from non-negative integers\n* 🤬 Avoid common profanity in generated IDs\n* 🎲 IDs appear randomized when encoding incremental numbers\n* 🧰 Decode IDs back into numbers\n* ↔️ Generate IDs with a minimum length, making them more uniform\n* 🔤 Generate IDs with a custom alphabet\n* 👩‍💻 Available in [multiple programming languages](https://sqids.org)\n* 👯‍♀️ Equally configured implementations produce the same IDs\n* 🍻 Small library with a permissive license","ref":"readme.html#features"},{"type":"extras","title":"🚀 Getting started - Sqids","doc":"[![Latest version](https://img.shields.io/hexpm/v/sqids.svg?style=flat)](https://hex.pm/packages/sqids)\n[![API reference](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/sqids/)\n[![Last commit](https://img.shields.io/github/last-commit/sqids/sqids-elixir.svg)](https://github.com/sqids/sqids-elixir/commits/main)\n\nThe package can be installed by adding `sqids` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:sqids, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#getting-started"},{"type":"extras","title":"👩‍💻 Examples - Sqids","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Default configuration - Sqids","doc":"```elixir\niex> {:ok, sqids} = Sqids.new()\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"86Rf07\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\n> **Note**\n> 🚧 Because of the algorithm's design, **multiple IDs can decode back into the\n> same sequence of numbers**. If it's important to your design that IDs are\n> canonical, you have to re-encode decoded numbers and check that the\n> generated ID matches.","ref":"readme.html#default-configuration"},{"type":"extras","title":"Convenience: create context at compile time - Sqids","doc":"Having to pass `sqids` context on every encode and decode call can be\ncumbersome.\n\nTo work around this, you can create context with `new!/0` or `new!/1` at compile\ntime if all options are either default or known at that moment:\n\n```elixir\niex> defmodule MyApp.CompileTimeSqids do\niex>   import Sqids.Hacks, only: [dialyzed_ctx: 1]\niex>   @context Sqids.new!()\niex>\niex>   def encode!(numbers), do: Sqids.encode!(dialyzed_ctx(@context), numbers)\niex>   def decode!(id), do: Sqids.decode!(dialyzed_ctx(@context), id)\niex> end\niex>\niex> numbers = [1, 2, 3]\niex> id = MyApp.CompileTimeSqids.encode!(numbers)\niex> ^id = \"86Rf07\"\niex> ^numbers = MyApp.CompileTimeSqids.decode!(id)\n```","ref":"readme.html#convenience-create-context-at-compile-time"},{"type":"extras","title":"Convenience: place context under your supervision tree - Sqids","doc":"This also allows you to encode and decode IDs without managing context.\n\nIf not all options are known at compile time but you'd still like to not pass\ncontext on every encode and decode call, you can `use Sqids`, which will\ngenerate functions that retrieve the underlying context transparently and call\n`Sqids` for you.\n\nThe context is stored in a uniquely named\n[`persistent_term`](https://www.erlang.org/doc/man/persistent_term), managed by\na uniquely named process, which is to be placed under your application's\nsupervision tree. Both names are derived from your module's.\n\n```elixir\niex> defmodule MyApp.SupervisedSqids do\niex>   use Sqids\niex>   # Functions encode/1, encode!/1, decode/1, decode!/1, etc\niex>   # will be generated.\niex>\niex>   @impl true\niex>   def child_spec() do\niex>       child_spec([\niex>           # alphabet: alphabet,     # Custom alphabet\niex>           # min_length: min_length, # Padding\niex>           # blocklist: blocklist    # Custom blocklist\niex>       ])\niex>   end\niex> end\niex>\niex>\niex> defmodule MyApp.Application do\niex>   # ...\niex>   def start(_type, _args) do\niex>      children = [\niex>        MyApp.SupervisedSqids.child_spec(),\niex>        # ...\niex>      ]\niex>\niex>      opts = [strategy: :one_for_one, name: MyApp.Supervisor]\niex>      Supervisor.start_link(children, opts)\niex>   end\niex> end\niex>\niex>\niex> {:ok, _} = MyApp.Application.start(:normal, [])\niex> numbers = [1, 2, 3]\niex> id = MyApp.SupervisedSqids.encode!(numbers)\niex> ^id = \"86Rf07\"\niex> ^numbers = MyApp.SupervisedSqids.decode!(id)\n```","ref":"readme.html#convenience-place-context-under-your-supervision-tree"},{"type":"extras","title":"Custom configuration - Sqids","doc":"Examples of custom configuration follow. All options are applicable to the two\nconvenient ways of creating context shown above.\n\nNote that different options can be used together for further customization.\nCheck the [API reference](https://hexdocs.pm/sqids/api-reference.html) for\ndetails.","ref":"readme.html#custom-configuration"},{"type":"extras","title":"Padding: generated IDs have a minimum length - Sqids","doc":"```elixir\niex> {:ok, sqids} = Sqids.new(min_length: 10)\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"86Rf07xd4z\" # instead of \"86Rf07\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\n(Older IDs, for ex. generated with a previous configuration in which padding\nwas not yet enforced or a different length was configured, can still be\ndecoded.)","ref":"readme.html#padding-generated-ids-have-a-minimum-length"},{"type":"extras","title":"Using a custom alphabet - Sqids","doc":"Generated IDs will only contain characters from the chosen alphabet, which is\nsensitive to both case and order.\n\n```elixir\niex> {:ok, sqids} = Sqids.new(alphabet: \"cdefhjkmnprtvwxy2345689\")\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"wc9xdr\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\nIn order to decode IDs back, they need to be in the same alphabet.\n\nFor practical reasons, the standard limits custom alphabets to ASCII\ncharacters.\n\n(Thanks to @benjiwheeler for his suggestion for [a set of unambiguous looking\ncharacters](https://stackoverflow.com/questions/11919708/set-of-unambiguous-looking-letters-numbers-for-user-input/58098360#58098360)\non Stack Overflow.)","ref":"readme.html#using-a-custom-alphabet"},{"type":"extras","title":"Profanity: excluding specific words from the IDs - Sqids","doc":"As an example, set [the ID generated with default\noptions](#default-configuration) as the blocklist.\n\n```elixir\niex> {:ok, sqids} = Sqids.new(blocklist: [\"86Rf07\"])\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"se8ojk\" # see how \"86Rf07\" was censored\niex> ^numbers = Sqids.decode!(sqids, id)\n```","ref":"readme.html#profanity-excluding-specific-words-from-the-ids"},{"type":"extras","title":"📚 API Reference - Sqids","doc":"The API reference can be found on\n[HexDocs](https://hexdocs.pm/sqids/api-reference.html).","ref":"readme.html#api-reference"},{"type":"extras","title":"📝 License - Sqids","doc":"[MIT](LICENSE)","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}